%define name	mono
%define version 1.0.2
%define release 1mdk

%define major 0
%define majorminor 0
%define libname %mklibname %{name} %{major}
%define runtimename %mklibname %{name}

Summary:	Mono Runtime.
Name:		%name
Version:	%version
Release:	%release
License:	GPL/LGPL/BSD
Group:		Development/Other
Source0:	http://www.go-mono.com/archive/%version/%name-%version.tar.bz2
Source1:	http://www.go-mono.com/archive/%version/mcs-%version.tar.bz2
Patch:		mono-1.0.1-sqlite.patch.bz2
URL:		http://www.go-mono.com/
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
BuildRequires:	libglib2-devel >= 2.2.0
BuildRequires:	icu-devel
BuildRequires:	bison
#gw for bootstrapping
BuildRequires:	mono
Requires:	libmono = %version-%release
Requires:	libmono-runtime = %version-%release
# Since mono 0.91 (mdk 10.0) we can rely on included config
Obsoletes:	mono-config
Provides:	mono-config
# old pnet doesn't use alternatives for ilasm
Conflicts:	pnet =< 0.6.2

%description
Mono is an implementation of the ECMA Common Language Infrastructure,
it contains both a just-in-time compiler for maximum performance, and
an interpeter.  It can also be used to run programs from the .NET
Framework.

%package doc
Summary:	Documentation for the Mono runtime
Group:		Development/Other
Requires:	mono

%description doc
Mono is an implementation of the ECMA Common Language Infrastructure,
it contains both a just-in-time compiler for maximum performance, and
an interpeter.  It can also be used to run programs from the .NET
Framework.
This package provides documentation for the Mono runtime.

%package -n %libname
Summary:	Libraries for the Mono runtime.
Group:		System/Libraries
Provides:	libmono = %version-%release
Requires: 	libgdiplus

%description -n %libname
Mono is an implementation of the ECMA Common Language Infrastructure,
it contains both a just-in-time compiler for maximum performance, and
an interpeter.  It can also be used to run programs from the .NET
Framework.
This package provides the versioned libraries for the Mono runtime.

%package -n %runtimename-runtime
Summary:	Libraries for the Mono runtime.
Group:		Development/Other
Requires:	libmono = %version-%release

%description -n %runtimename-runtime
Mono is an implementation of the ECMA Common Language Infrastructure,
it contains both a just-in-time compiler for maximum performance, and
an interpeter.  It can also be used to run programs from the .NET
Framework.
This package provides the non-versioned libraries for the Mono runtime.

%package data-sqlite
Summary:	SQLite database connectivity for mono
Group:		Development/Other
Requires:	%mklibname sqlite 0

%description data-sqlite
Mono is an implementation of the ECMA Common Language Infrastructure,
it contains both a just-in-time compiler for maximum performance, and
an interpeter.  It can also be used to run programs from the .NET
Framework.
This package provides the connectivity to the sqlite database for Mono.

%package -n %libname-devel
Summary:	Tools required to embed the Mono runtime.
Group:		Development/Other
PreReq:		%{name} = %{version}-%{release}
Requires:	glib2-devel >= 2.2.0
Requires:	%libname = %version-%release
Requires:	mono = %version-%release
Provides:	mono-devel = %version-%release
Provides:	libmono-devel = %version-%release

%description -n %libname-devel
Header files and libraries used to embed the Mono runtime in an application.

%package -n jay
Summary:	Jay is a LALR(1) parser generator for Java and C#.
Group:		Development/Other

%description -n jay
Jay is a LALR(1) parser generator for Java and C#.

This is a port of Jay to C#, the original Jay can be found here:
http://www.informatik.uni-osnabrueck.de/bernd/jay/
	


%prep
%setup -c mono -q -a 1
ln -s %name-%version %name
ln -s mcs-%version mcs
%patch -p0

%build
cd %name-%version
%configure2_5x --with-nptl
# 0.23: parallel make is broken
make bootstrap

#gw bootstrap does this for us
# build in mcs directory so we can install jay and monostyle
#cd ../mcs-%version
#make prefix=%{_prefix}
#cd -

%install
rm -rf %{buildroot} mono/installed-docs
cd %name-%version
%makeinstall_std

# install jay
cd ../mcs-%version/jay
install jay %{buildroot}%{_bindir}
install jay.1 %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_datadir}/jay
install ACKNOWLEDGEMENTS  %{buildroot}%{_datadir}/jay
install NEW_FEATURES %{buildroot}%{_datadir}/jay
install NOTES %{buildroot}%{_datadir}/jay
install README %{buildroot}%{_datadir}/jay
install README.jay %{buildroot}%{_datadir}/jay
install skeleton %{buildroot}%{_datadir}/jay
install skeleton.cs %{buildroot}%{_datadir}/jay
cd -

#install monostyle
cd ../mcs-%version/tools
install monostyle.exe %{buildroot}%{_bindir}
cat > %buildroot/%{_bindir}/monostyle << EOF
#!/bin/sh
exec /usr/bin/mono /usr/bin/monostyle.exe "\$@"
EOF
chmod 755 %buildroot/%{_bindir}/monostyle
cd -

# don't conflict with pnet, use alternatives
mv %{buildroot}%{_mandir}/man1/ilasm.1 %{buildroot}%{_mandir}/man1/ilasm.mono.1
mv %{buildroot}%{_bindir}/ilasm %{buildroot}%{_bindir}/ilasm.mono
mv %{buildroot}%{_bindir}/al %{buildroot}%{_bindir}/al.mono
mv %{buildroot}%{_bindir}/resgen %{buildroot}%{_bindir}/resgen.mono

mv %buildroot%_datadir/libgc-mono installed-docs

%clean
rm -rf %{buildroot}


%post -n %libname -p /sbin/ldconfig

%post 
update-alternatives --install %{_bindir}/ilasm ilasm %{_bindir}/ilasm.mono 10
update-alternatives --install %{_mandir}/man1/ilasm.1.bz2 man-ilasm %{_mandir}/man1/ilasm.mono.1.bz2 10
update-alternatives --install %{_bindir}/al al %{_bindir}/al.mono 10
update-alternatives --install %{_bindir}/resgen resgen %{_bindir}/resgen.mono 10

%postun -n %libname -p /sbin/ldconfig

%postun
[ $1 = 0 ] || exit 0
update-alternatives --remove ilasm  %{_bindir}/ilasm.mono
update-alternatives --remove man-ilasm  %{_mandir}/man1/ilasm.mono.1.bz2
update-alternatives --remove al  %{_bindir}/al.mono
update-alternatives --remove resgen  %{_bindir}/resgen.mono


%files
%defattr(-, root, root)
%dir %{_sysconfdir}/mono
%config(noreplace) %{_sysconfdir}/mono/DefaultWsdlHelpGenerator.aspx
%config(noreplace) %{_sysconfdir}/mono/browscap.ini
%config(noreplace) %{_sysconfdir}/mono/machine.config
%config  %{_sysconfdir}/mono/config
%{_bindir}/*[^jay]
%{_mandir}/man1/[a-i]*
# bah, no workies
#%{_mandir}/man1/*[^jay.1.bz2]
%{_mandir}/man1/[k-z]*
%{_mandir}/man5/*

%files doc
%defattr(-, root, root)
%doc mono*/AUTHORS mono*/COPYING.LIB mono*/ChangeLog mono*/NEWS mono*/README
%doc mono*/docs/*[^Makefile-Makefile.in]
%doc mcs*/docs/clr-abi.txt mcs*/docs/compiler mcs*/docs/control-flow-analysis.txt
%doc mono/installed-docs/*

%files -n %libname
%defattr(-, root, root)
%{_libdir}/*.so.*

%files data-sqlite
%defattr(-, root, root)
%{_libdir}/mono/1.0/Mono.Data.SqliteClient.dll
%{_libdir}/mono/gac/Mono.Data.SqliteClient/

%files -n %runtimename-runtime
%defattr(-, root, root)
%{_libdir}/*.dll
%dir %{_libdir}/mono
%dir %{_libdir}/mono/1.0/
%dir %{_libdir}/mono/2.0/
%dir %{_libdir}/mono/gac/
%_libdir/mono/1.0/Accessibility*
%_libdir/mono/1.0/ByteFX.Data*
%_libdir/mono/1.0/Commons.Xml.Relaxng*
%_libdir/mono/1.0/I18N*
%_libdir/mono/1.0/IBM.Data.DB2*
%_libdir/mono/1.0/ICSharpCode.SharpZipLib*
%_libdir/mono/1.0/Microsoft*
%_libdir/mono/1.0/Mono.CSharp.Debugger*
%_libdir/mono/1.0/Mono.Cairo*
%_libdir/mono/1.0/Mono.Data.SybaseClient*
%_libdir/mono/1.0/Mono.Data.Tds*
%_libdir/mono/1.0/Mono.GetOptions*
%_libdir/mono/1.0/Mono.Http*
%_libdir/mono/1.0/Mono.Posix*
%_libdir/mono/1.0/Mono.Security*
%_libdir/mono/1.0/Novell*
%_libdir/mono/1.0/Npgsql*
%_libdir/mono/1.0/PEAPI*
%_libdir/mono/1.0/System*
%_libdir/mono/1.0/cscompmgd*
%_libdir/mono/1.0/nunit*
%_libdir/mono/1.0/*.exe
%_libdir/mono/2.0/*
%_libdir/mono/gac/Accessibility*
%_libdir/mono/gac/ByteFX.Data*
%_libdir/mono/gac/Commons.Xml.Relaxng*
%_libdir/mono/gac/I18N*
%_libdir/mono/gac/IBM.Data.DB2*
%_libdir/mono/gac/ICSharpCode.SharpZipLib*
%_libdir/mono/gac/Microsoft*
%_libdir/mono/gac/Mono.CSharp.Debugger*
%_libdir/mono/gac/Mono.Cairo*
%_libdir/mono/gac/Mono.Data.SybaseClient*
%_libdir/mono/gac/Mono.Data.Tds*
%_libdir/mono/gac/Mono.GetOptions*
%_libdir/mono/gac/Mono.Http*
%_libdir/mono/gac/Mono.Posix*
%_libdir/mono/gac/Mono.Security*
%_libdir/mono/gac/Novell*
%_libdir/mono/gac/Npgsql*
%_libdir/mono/gac/PEAPI*
%_libdir/mono/gac/System*
%_libdir/mono/gac/cscompmgd*
%_libdir/mono/gac/nunit*

%files -n %libname-devel
%defattr(-, root, root)
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/*.so
%{_libdir}/pkgconfig/*
%dir %{_includedir}/mono
%{_includedir}/mono/*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*

%files -n jay
%defattr(-, root, root)
%{_bindir}/jay
%{_mandir}/man1/jay*
%dir %{_datadir}/jay
%{_datadir}/jay/*


%changelog
* Wed Sep 22 2004 Goetz Waschk <waschk@linux-mandrake.com> 1.0.2-1mdk
- New release 1.0.2

* Wed Sep  1 2004 Gtz Waschk <waschk@linux-mandrake.com> 1.0.1-3mdk
- arrgh, fix patch application

* Mon Aug 30 2004 Gtz Waschk <waschk@linux-mandrake.com> 1.0.1-2mdk
- split out sqlite package

* Thu Aug 12 2004 Gtz Waschk <waschk@linux-mandrake.com> 1.0.1-1mdk
- new version

* Wed Jul 28 2004 Gtz Waschk <waschk@linux-mandrake.com> 1.0-2mdk
- rebuild for new rpm

* Wed Jun 30 2004 Gtz Waschk <waschk@linux-mandrake.com> 1.0-1mdk
- new version

* Wed Jun 16 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.96-1mdk
- fix devel provides
- fix groups
- new version

* Thu Jun  3 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.95-2mdk
- add nptl support
- don't run make in the mcs dir
- fix libgdiplus dependancy
- don't depend on cairo

* Wed Jun  2 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.95-1mdk
- fix doc section
- fix gdiplus dep
- fix mcs bootstrap
- new version

* Tue May 25 2004 Marcel Pol <mpol@mandrake.org> 0.91-4mdk
- make unversioned symlinks for mcs and mono for %%build
- add monostyle

* Thu May 13 2004 Marcel Pol <mpol@mandrake.org> 0.91-3mdk
- don't conflict but obsolete mono-config

* Tue May 11 2004 Marcel Pol <mpol@mandrake.org> 0.91-2mdk


* Wed May  5 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.91-1mdk
- add /usr/lib/mono to the runtime package
- fix source URL
- New release 0.91

* Fri Apr 30 2004 Marcel Pol <mpol@mandrake.org> 0.31-2mdk
- make resgen an alternative

* Mon Apr 19 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.31-1mdk
- spec fixes
- autoconf2.5 call
- fix source location
- new version

* Mon Feb 16 2004 Marcel Pol <mpol@mandrake.org> 0.30.1-1mdk
- 0.30.1

* Mon Feb 09 2004 Marcel Pol <mpol@mandrake.org> 0.30-3mdk
- config file in seperate package mono-config

* Sat Feb 07 2004 Marcel Pol <mpol@mandrake.org> 0.30-2mdk
- use real 0.30 release
- buildrequires libgdiplus-devel
- replace mono config on upgrade

* Sun Feb 01 2004 Marcel Pol <mpol@mandrake.org> 0.30-1mdk
- 0.30
- /usr/bin/al added as alternative

* Sat Jan 31 2004 Marcel Pol <mpol@mandrake.org> 0.29-2mdk
- manually edit configfile (fixes partly #7047 #7201)

* Mon Dec 22 2003 Marcel Pol <mpol@mandrake.org> 0.29-1mdk
- From Quel Qun <kelk1@hotmail.com>
    - 0.29
    - use included gc
- use alternatives for ilasm
- conflict with old pnet
- include jay for mono-debugger
- update buildrequires and requires for devel
- fix license
- don't use gcc -gdwarf anymore

* Sat Aug 16 2003 Marcel Pol <mpol@gmx.net> 0.26-1mdk
- 0.26

* Tue Jul 08 2003 Marcel Pol <mpol@gmx.net> 0.25-1mdk
- 0.25

* Sun Jun 09 2003 Marcel Pol <mpol@gmx.net> 0.24-2mdk
- s/ilasm/ilasm-mono - don't conflict with pnet

* Tue Apr 08 2003 Marcel Pol <mpol@gmx.net> 0.24-1mdk
- 0.24

* Tue Apr 08 2003 Marcel Pol <mpol@gmx.net> 0.23-5mdk
- libpolicy; non-versioned libs in a seperate package

* Sat Apr 05 2003 Marcel Pol <mpol@gmx.net> 0.23-4mdk
- include some docs

* Tue Apr 01 2003 Marcel Pol <mpol@gmx.net> 0.23-3mdk
- fix wrapper scripts

* Sun Mar 23 2003 Marcel Pol <mpol@gmx.net> 0.23-2mdk
- don't use hardcoded paths in configure

* Tue Mar 18 2003 Marcel Pol <mpol@gmx.net> 0.23-1mdk
- initial mandrake release
